//=============================================================================
// ZombiePawns.
// Use this stuff the way you like.
// Copy the scripts for on mods and sell it for money... I don't really care!
// As longs as your not orginal author.. you dont have the good feeling if you
// copy the scripts. Would be nice to ask if your gonna for premission to use em.
//														Scripted up by .:..:
//=============================================================================
class ZombiePawns expands ScriptedPawn
	Abstract;
// Never spawned class. Main script for 2 sub classes

// Variables:
var vector MoveVect,OldMoveVect;
var TriggeredTimeMaster TimeMasterObject;
var NavigationPoint MovingPoint;
var Actor SpecialCost,Node,OldNode,Node2;
var(Sounds) sound DiedS[4];
var bool bSuccess,bOnce;

// Configurable variables!
var() config int ZombieRunSpeed,ZombieJumpZ,ZombieHealth,BiteDamage,ZombieAccelRate,ZombieSwimSpeed,LungeDamage,
LungeRange,MaxSpawnedZombies;
var() config bool bGotGreenBlood,bCanDoLungeAttack,bHardCoreEnemy;

// Animations:
var(Animations) name RunAnim,WalkAnim,SwimAnim,IdleAnim[2],DiedAnim[4],GutHitAnim,HeadHitAnim,
LeftHitAnim,RightHitAnim,MeleeAnim,FighterAnim,InAirAnim,GotYaAnim,LungeAnim;

// Functions:
function PostBeginPlay()
{
	Super.PostBeginPlay();

	if( TimeMasterObject==None ) // If no time master objects, find one
		Foreach AllActors(class'TriggeredTimeMaster',TimeMasterObject)
			Break;
	if( TimeMasterObject==None ) // no was found, spawn one then.
		TimeMasterObject = Spawn(class'TriggeredTimeMaster');
	bGreenBlood = bGotGreenBlood;
	GroundSpeed = ZombieRunSpeed;
	JumpZ = ZombieJumpZ;
	Health = ZombieHealth;
	AccelRate = ZombieAccelRate;
	WaterSpeed = ZombieSwimSpeed;
}
Event DayNightChange()
{
	Enemy = None;
	OldEnemy = None;
	GoToState('DoIdle','Begin');
}
function PreSetMovement()
{
	MaxDesiredSpeed = 0.79 + 0.07 * skill;
	bCanJump = true;
	bCanWalk = true;
	bCanSwim = true;
	bCanFly = false;
	MinHitWall = -0.6;
	bCanOpenDoors = true;
	bCanDoSpecial = true;
}
Auto state DoIdle
{
Ignores Tick;
	function BeginState()
	{
		NextState = 'DoIdle';
		PreSetMovement();
		SetTimer(3*FRand(),false);
		if( Region.Zone.bWaterZone )
			SetPhysics(PHYS_Swimming);
		else SetPhysics(PHYS_Falling);
	}
	function NavigationPoint GetAPoint()
	{
		local NavigationPoint N;
		local int Num,Num2;

		For( N=Level.NavigationPointList; N!=None; N=N.nextNavigationPoint )
			if( ZombiePatrol(N)!=None && ZombiePatrol(N).bNightHideOut==TimeMasterObject.bDayTime )
				Num++;
		if( Num==0 )
			GoTo 'Skipper';
		Num = Rand(Num);
		For( N=Level.NavigationPointList; N!=None; N=N.nextNavigationPoint )
		{
			if( ZombiePatrol(N)!=None && ZombiePatrol(N).bNightHideOut==TimeMasterObject.bDayTime )
			{
				if( Num==Num2 )
					Return N;
				Num2++;
			}
		}
	Skipper:
		Num = 0;
		For( N=Level.NavigationPointList; N!=None; N=N.nextNavigationPoint )
			Num++;
		Num = Rand(Num);
		Num2 = 0;
		For( N=Level.NavigationPointList; N!=None; N=N.nextNavigationPoint )
		{
			if( Num==Num2 )
				Return N;
			Num2++;
		}
		Return None;
	}
	function HitWall( vector HitNormal, actor HitWall )
	{
		DoJump();
	}
	function CheckEnemys()
	{
		local Pawn P;

		For( P=Level.PawnList; P!=None; P=P.NextPawn )
			if( ZombiePawns(P)==None && P.Health>0 && VSize(P.Location-Location)<1000 &&
			 LineOfSightTo(P) && SetEnemy(P) )
				Return;
	}
	function Landed( vector Normal )
	{
		SetPhysics(PHYS_Walking);
	}
	function Timer()
	{
		if( FRand()<0.2 )
			DoJump();
		SetTimer(2+6*FRand(),false);
		if( TimeMasterObject.bDayTime && Region.Zone.Class==class'DayZone' )
			TakeDamage(50,None,vect(0,0,0),vect(0,0,0),'burned');
	}
Begin:
	if( Physics==PHYS_Falling )
	{
		PlayInAir();
		WaitForLanding();
	}
	MovingPoint = GetAPoint();
	if( MovingPoint!=None )
		GoTo 'MoveAtPoint';
Wandering:
	CheckEnemys();
	MoveVect = VRand()*400+Location;
	PlayRunning();
	MoveTo(MoveVect,GroundSpeed);
	Acceleration = vect(0,0,0);
	PlayWaiting();
	Sleep(0.5);
	GoTo('Begin');
MoveAtPoint:
	CheckEnemys();
	PlayRunning();
	if( actorReachable(MovingPoint) )
	{
		MoveToward(MovingPoint,GroundSpeed);
		Acceleration = vect(0,0,0);
		PlayWaiting();
		Sleep(1);
		GoTo 'Wandering';
	}
	OldNode = Node;
	Node = FindPathToward(MovingPoint);
	if( Node==None )
	{
		//BroadcastMessage("No path found to"@MovingPoint);
		PlayWaiting();
		Sleep(1);
		GoTo 'Wandering';
	}
	if( Node.IsA('LiftCenter') && OldNode.IsA('LiftCenter') && !LiftMoving(LiftCenter(Node).LiftTag) )
	{
		SetTimer(0,false);
		Acceleration = vect(0,0,0);
		PlayWaiting();
		Sleep(1);
		SetTimer(3,false);
		GoTo 'MoveAtPoint';
	}
	if( OldNode.IsA('LiftExit') && Node.IsA('LiftCenter') )
	{
ReCheck:
		if( Location.Z>(Node.Location.Z-LiftCenter(Node).MaxZDiffAdd-40) &&
		 Location.Z<(Node.Location.Z+LiftCenter(Node).MaxZDiffAdd+40) )
		{
			if( LiftCenter(Node).LiftTrigger!='' && !bOnce )
			{
				bOnce = True;
				SpecialCost = GetTrigger(LiftExit(OldNode).LiftTrigger);
				if( SpecialCost!=None )
				{
IWantTryAgain:
					if( !actorReachable(SpecialCost) )
					{
						Node2 = FindPathToward(SpecialCost);
						if( Node2==None )
						{
							PlayRunning();
							MoveToward(SpecialCost,GroundSpeed);
						}
						else
						{
							PlayRunning();
							MoveToward(Node2,GroundSpeed);
							if( OldMoveVect==Node2.Location )
							{
								Acceleration = vect(0,0,0);
								PlayWaiting();
								Sleep(0.5);
							}
							OldMoveVect = Node2.Location;
							GoTo 'IWantTryAgain';
						}
					}
					else
					{
						PlayRunning();
						MoveToward(SpecialCost,GroundSpeed);
						Acceleration = vect(0,0,0);
						PlayWaiting();
						Sleep(0.5);
					}
				}
			}
			GoTo 'Skipp';
		}
		else
		{
			if( LiftExit(OldNode).LiftTrigger!='' )
			{
				SpecialCost = GetTrigger(LiftExit(OldNode).LiftTrigger);
				if( SpecialCost!=None )
				{
IWantTryAgain2:
					if( !actorReachable(SpecialCost) )
					{
						Node2 = FindPathToward(SpecialCost);
						if( Node2==None )
						{
							PlayRunning();
							MoveToward(SpecialCost,GroundSpeed);
						}
						else
						{
							PlayRunning();
							MoveToward(Node2,GroundSpeed);
							if( OldMoveVect==Node2.Location )
							{
								Acceleration = vect(0,0,0);
								PlayWaiting();
								Sleep(0.5);
							}
							OldMoveVect = Node2.Location;
							GoTo 'IWantTryAgain2';
						}
					}
					else
					{
						PlayRunning();
						MoveToward(SpecialCost,GroundSpeed);
						Acceleration = vect(0,0,0);
						PlayWaiting();
						Sleep(0.5);
						GoTo 'MoveAtPoint';
					}
				}
			}
			Acceleration = vect(0,0,0);
			PlayWaiting();
			TriggerMovers(LiftCenter(Node).LiftTag);
			Sleep(1);
			GoTo 'ReCheck';
		}
	}
	else bOnce = False;
Skipp:
	if( Node.IsA('LiftExit') && !OldNode.IsA('LiftCenter') )
	{
		if( LiftExit(Node).LiftTrigger!='' )
			SpecialCost = GetTrigger(LiftExit(Node).LiftTrigger);
		else SpecialCost = None;
		if( SpecialCost!=None )
		{
DoAgain:
			if( !actorReachable(SpecialCost) )
			{
				Node2 = FindPathToward(SpecialCost);
				if( Node2==None )
				{
					PlayRunning();
					MoveToward(SpecialCost,GroundSpeed);
				}
				else
				{
					PlayRunning();
					MoveToward(Node2,GroundSpeed);
					if( OldMoveVect==Node2.Location )
					{
						Acceleration = vect(0,0,0);
						PlayWaiting();
						Sleep(0.5);
					}
					OldMoveVect = Node2.Location;
					GoTo 'DoAgain';
				}
			}
			else
			{
				PlayRunning();
				MoveToward(SpecialCost,GroundSpeed);
				Acceleration = vect(0,0,0);
				PlayWaiting();
				Sleep(0.5);
				GoTo 'MoveAtPoint';
			}
		}
	}
	MoveToward(Node,GroundSpeed);
	if( OldMoveVect==Node.Location )
	{
		Acceleration = vect(0,0,0);
		PlayWaiting();
		Sleep(0.5);
	}
	OldMoveVect = Node.Location;
	GoTo 'MoveAtPoint';
}
function WhatToDoNext(name LikelyState, name LikelyLabel)
{
	bQuiet = false;
	Enemy = None;
	if ( OldEnemy != None )
	{
		Enemy = OldEnemy;
		OldEnemy = None;
		GoToState('BiteLikeHell');
		Return;
	}
	GoToState('DoIdle');
}
function bool SetEnemy( Pawn NewEnemy )
{
	if( NewEnemy==None || NewEnemy.Health<=0 ) Return False;
	if( ZombiePawns(NewEnemy)!=None || FlockPawn(NewEnemy)!=None ||
	 FlockMasterPawn(NewEnemy)!=None ) Return False;
	if( TimeMasterObject.bDayTime && NewEnemy.Region.Zone!=None && NewEnemy.Region.Zone.Class==class'DayZone' )
		Return false;

	if ( !bFirstHatePlayer && NewEnemy.bIsPlayer && (FirstHatePlayerEvent != '') )
		TriggerFirstHate();
	if( Enemy!=None && Enemy!=NewEnemy )
		OldEnemy = Enemy;
	Enemy = NewEnemy;
	if( IsInState('DoIdle') )
		GoToState('BiteLikeHell');
	Return True;
}
function damageAttitudeTo(pawn Other)
{
	local Pawn P;

	For( P=Level.PawnList; P!=None; P=P.NextPawn )
		if( ZombiePawns(P)!=None && P.Health>0 && VSize(P.Location-Location)<600 )
			ZombiePawns(P).SetEnemy(Other); // Warn closest "friends"
	SetEnemy(Other);
}
function Tick( float DeltaTime )
{
	GoToState('DoIdle');
}
function eAttitude AttitudeToCreature(Pawn Other)
{
	if( ZombiePawns(Other)!=None )
		return ATTITUDE_Friendly;
	else
		return ATTITUDE_Hate;
}

// Animation related functions:

function PlayGutHit(float tweentime)
{
	if ( (LastPainTime - Level.TimeSeconds < 0.3) && (LastPainAnim == GutHitAnim) )
	{
		if (FRand() < 0.5)
			TweenAnim(LeftHitAnim, tweentime);
		else
			TweenAnim(RightHitAnim, tweentime);
	}
	else
		TweenAnim(GutHitAnim, tweentime);
}
function PlayHeadHit(float tweentime)
{
	if ( (LastPainTime - Level.TimeSeconds < 0.3) && (LastPainAnim == HeadHitAnim) )
	{
		if (FRand() < 0.5)
			TweenAnim(LeftHitAnim, tweentime);
		else
			TweenAnim(RightHitAnim, tweentime);
	}
	else
		TweenAnim(HeadHitAnim, tweentime);
}

function PlayLeftHit(float tweentime)
{
	if ( (LastPainTime - Level.TimeSeconds < 0.3) && (LastPainAnim == LeftHitAnim) )
		TweenAnim(GutHitAnim, tweentime);
	else
		TweenAnim(LeftHitAnim, tweentime);
}

function PlayRightHit(float tweentime)
{
	if ( (LastPainTime - Level.TimeSeconds < 0.3) && (LastPainAnim == RightHitAnim) )
		TweenAnim(GutHitAnim, tweentime);
	else
		TweenAnim(RightHitAnim, tweentime);
}
function PlayWaiting()
{
	if (Region.Zone.bWaterZone)
	{
		LoopAnim(SwimAnim, 0.6  + 0.9 * FRand());
		return;
	}
	LoopAnim(IdleAnim[Rand(2)], 0.8 + 0.6 * FRand());
}
function TweenToRunning(float tweentime)
{
	if (Region.Zone.bWaterZone)
	{
		if ( AnimSequence == MeleeAnim && IsAnimating() )
			return;
		if ( AnimSequence != SwimAnim || !bAnimLoop )
			TweenAnim(SwimAnim, tweentime);
	}
	else
	{
		if ( AnimSequence == MeleeAnim && IsAnimating() )
			return;
		if ( (AnimSequence != RunAnim) || !bAnimLoop )
			TweenAnim(RunAnim, tweentime);
	}
}
function TweenToWalking(float tweentime)
{
	if (Region.Zone.bWaterZone)
	{
		if ( AnimSequence == MeleeAnim && IsAnimating() )
			return;
		if ( AnimSequence != WalkAnim || !bAnimLoop )
			TweenAnim(WalkAnim, tweentime);
	}
	else
	{
		if ( AnimSequence == MeleeAnim && IsAnimating() )
			return;
		if ( (AnimSequence != WalkAnim) || !bAnimLoop )
			TweenAnim(WalkAnim, tweentime);
	}
}
function TweenToWaiting(float tweentime)
{
	if (Region.Zone.bWaterZone)
		TweenAnim(SwimAnim, tweentime);
	else
		TweenAnim(IdleAnim[Rand(2)], tweentime);
}
function TweenToPatrolStop(float tweentime)
{
	TweenToWaiting(tweentime);
}
function PlayPatrolStop()
{
	PlayWaiting();
}

function PlayWaitingAmbush()
{
	PlayWaiting();
}

function PlayChallenge()
{
	TweenToFighter(0.1);
}
function PlayRunning()
{
	if (Region.Zone.bWaterZone)
		LoopAnim(SwimAnim, -1.0/WaterSpeed,, 0.4);
	else
		LoopAnim(RunAnim, -1.1/GroundSpeed,, 0.4);
}
function PlayWalking()
{
	if (Region.Zone.bWaterZone)
		LoopAnim(SwimAnim, -1.0/WaterSpeed,, 0.4);
	else
		LoopAnim(WalkAnim, -1.3/GroundSpeed,, 0.4);
}
function PlayThreatening()
{
	LoopAnim(FighterAnim);
}
function PlayTurning()
{
	TweenAnim(FighterAnim, 0.35);
}
function PlayDying(name DamageType, vector HitLocation)
{
	local int Ran;

	Ran = Rand(4);
	PlaySound(DiedS[Ran], SLOT_Talk, 4 * TransientSoundVolume);
	PlayAnim(DiedAnim[Ran], 0.7, 0.1);
}
function TweenToFalling()
{
	TweenAnim(InAirAnim, 0.4);
}
function PlayInAir()
{
	TweenAnim(InAirAnim, 0.4);
}
function PlayLanded(float impactVel)
{
	TweenAnim(GutHitAnim, 0.25);
}
function PlayVictoryDance()
{
	PlayAnim(GotYaAnim, 0.3, 0.1);
	PlaySound(Roam, SLOT_Interact);
}
function PlayMeleeAttack()
{
	PlayAnim(MeleeAnim,2);
	Target = Enemy;
	if ( MeleeDamageTarget(BiteDamage, (BiteDamage * 800.0 * Normal(Target.Location - Location))) )
		PlaySound(Threaten, SLOT_Talk); //FIXME - stingdamage instead of projectile
}
function bool MeleeDamageTarget(int hitdamage, vector pushdir)
{
	local vector HitLocation, HitNormal, TargetPoint;
	local actor HitActor;
	local float Scale;
	local Zombie NewZ;
	local int i;
	local Pawn P;

	// check if still in melee range
	If ( (VSize(Target.Location - Location) <= MeleeRange * 1.4 + Target.CollisionRadius + CollisionRadius)
		&& ((Physics == PHYS_Flying) || (Physics == PHYS_Swimming) || (Abs(Location.Z - Enemy.Location.Z)
			<= FMax(CollisionHeight, Enemy.CollisionHeight) + 0.5 * FMin(CollisionHeight, Enemy.CollisionHeight))) )
	{
		HitActor = Trace(HitLocation, HitNormal, Enemy.Location, Location, false);
		if ( HitActor != None )
			return false;
		Scale = Target.CollisionHeight/Class'Zombie'.Default.CollisionHeight;
		Target.TakeDamage(hitdamage, Self,HitLocation, pushdir, 'hacked');
		if( MaxSpawnedZombies>=0 )
			For( P=Level.PawnList; P!=None; P=P.NextPawn )
				if( ZombiePawns(P)!=None )
					i++;
		if( Pawn(Target)!=None && Pawn(Target).Health<=0 && ((MaxSpawnedZombies>=0 && MaxSpawnedZombies<i) || MaxSpawnedZombies<0) )
		{
			NewZ = Spawn(class'Zombie',,,Target.Location,Target.Rotation);
			if( NewZ!=None )
			{
				NewZ.SetCollisionSize(Default.CollisionRadius*Scale,Default.CollisionHeight*Scale);
				NewZ.DrawScale = Default.DrawScale*Scale;
				NewZ.Health = ZombieHealth*Scale;
				NewZ.BiteDamage = BiteDamage*Scale;
				NewZ.LungeDamage = LungeDamage*Scale;
			}
		}
		return true;
	}
	return false;
}
function Killed(pawn Killer, pawn Other, name damageType)
{
	if( Other==OldEnemy )
		OldEnemy = None;
	if( Other==Enemy )
	{
		Enemy = None;
		WhatToDoNext('','');
	}
}
function Actor GetTrigger( name Oth )
{
	local Actor A;

	ForEach AllActors(class'Actor',A,Oth)
		Return A;
	Return None;
}
function DoJump()
{
	if ( Physics == PHYS_Walking )
	{
		PlayInAir();
		Velocity.Z = JumpZ;
		if ( Base != None && Base != Level )
			Velocity.Z += Base.Velocity.Z;
		SetPhysics(PHYS_Falling);
	}
	else if ( Physics == PHYS_Swimming )
		Velocity.Z += JumpZ*2;
}
state BiteLikeHell
{
Ignores Tick;
	function BeginState()
	{
		NextState = 'BiteLikeHell';
		if( Region.Zone.bWaterZone )
			SetPhysics(PHYS_Swimming);
		else SetPhysics(PHYS_Falling);
		SetTimer(8*FRand(),false);
	}
	function CheckEnemys()
	{
		local Pawn P;

		For( P=Level.PawnList; P!=None; P=P.NextPawn )
			if( ZombiePawns(P)==None && P.Health>0 && VSize(P.Location-Location)<1000 &&
			 LineOfSightTo(P) && SetEnemy(P) )
				Return;
	}
	function Landed( vector Normal )
	{
		SetPhysics(PHYS_Walking);
	}
	function HitWall( vector HitNormal, actor HitWall )
	{
		DoJump();
	}
	function Bump( Actor Other )
	{
		if( Pawn(Other)!=None )
		{
			if( Pawn(Other)==Enemy && AnimSequence==LungeAnim )
			{
				if( bSuccess )
				{
					Target = Other;
					if( MeleeDamageTarget(LungeDamage,Velocity) )
					{
						bSuccess = False;
						PlaySound(Threaten, SLOT_Talk);
					}
				}
			}
			else
			{
				if( Pawn(Other)==Enemy )
					GoToState('BiteLikeHell','TryAgain');
				else if( !SetEnemy(Pawn(Other)) )
					DoJump();
			}
		}
	}
	function EnemyNotVisible()
	{
		if( !bHardCoreEnemy )
			GoToState('BiteLikeHell','CheckLastLocation');
	}
	function Timer()
	{
		if( FRand()<0.2 )
			DoJump();
		SetTimer(2+6*FRand(),false);
		if( TimeMasterObject.bDayTime && Region.Zone.Class==class'DayZone' )
		{
			DayNightChange();
			TakeDamage(50,None,vect(0,0,0),vect(0,0,0),'burned');
		}
	}
Begin:
	if( Physics==PHYS_Falling )
	{
		PlayInAir();
		WaitForLanding();
	}
MoveAtPoint:
	if( Enemy==None || Enemy.Class==None || Enemy.Health<=0 || Enemy.bDeleteMe )
	{
		Enemy = None;
		WhatToDoNext('','');
	}
	CheckEnemys();
	if( bCanDoLungeAttack && LineOfSightTo(Enemy) && VSize(Enemy.Location-Location)<LungeRange )
	{
		if (NeedToTurn(Enemy.Location))
			TurnToward(Enemy);
		bSuccess = True;
		PlayAnim(LungeAnim);
		Enable('Bump');
		Velocity = (Enemy.Location-Location)*2;
		Velocity.Z += VSize(Enemy.Location-Location);
		if( Region.Zone.bWaterZone )
			SetPhysics(PHYS_Swimming);
		else SetPhysics(PHYS_Falling);
		FinishAnim();
		if( Physics==PHYS_Falling )
		{
			PlayInAir();
			WaitForLanding();
		}
	}
	PlayRunning();
	if( actorReachable(Enemy) )
	{
		MoveToward(Enemy,GroundSpeed);
TryAgain:
		If ( (VSize(Enemy.Location - Location) <= MeleeRange * 1.4 + Enemy.CollisionRadius + CollisionRadius)
		&& ((Physics == PHYS_Flying) || (Physics == PHYS_Swimming) || (Abs(Location.Z - Enemy.Location.Z)
			<= FMax(CollisionHeight, Enemy.CollisionHeight) + 0.5 * FMin(CollisionHeight, Enemy.CollisionHeight))) )
		{
			if (NeedToTurn(Enemy.Location))
				TurnToward(Enemy);
			Disable('Bump');
			Acceleration = vect(0,0,0);
			PlayMeleeAttack();
			FinishAnim();
			Sleep(0.1);
			if( Enemy.Health<=0 || Enemy.Class==None || Enemy.bDeleteMe )
			{
				Enemy = None;
				WhatToDoNext('','');
			}
			GoTo 'TryAgain';
		}
		Enable('Bump');
		Acceleration = vect(0,0,0);
		PlayWaiting();
		Sleep(0.4);
		GoTo 'MoveAtPoint';
	}
	OldNode = Node;
	Node = FindPathToward(Enemy);
	if( Node==None )
	{
		Acceleration = vect(0,0,0);
		PlayWaiting();
		Sleep(1);
		if( LineOfSightTo(Enemy) )
		{
			MoveVect = VRand()*700+Location;
			PlayRunning();
			StrafeFacing(MoveVect,Enemy);
			GoTo 'MoveAtPoint';
		}
		Enemy = None;
		WhatToDoNext('','');
	}
	if( Node.IsA('LiftCenter') && OldNode.IsA('LiftCenter') && !LiftMoving(LiftCenter(Node).LiftTag) )
	{
		SetTimer(0,false);
		Acceleration = vect(0,0,0);
		PlayWaiting();
		Sleep(2);
		GoTo 'MoveAtPoint';
		SetTimer(2+6*FRand(),false);
	}
	if( OldNode.IsA('LiftExit') && Node.IsA('LiftCenter') )
	{
ReCheck:
		if( Location.Z>(Node.Location.Z-LiftCenter(Node).MaxZDiffAdd-40) &&
		 Location.Z<(Node.Location.Z+LiftCenter(Node).MaxZDiffAdd+40) )
		{
			if( LiftCenter(Node).LiftTrigger!='' )
			{
				SpecialCost = GetTrigger(LiftExit(OldNode).LiftTrigger);
				if( SpecialCost!=None )
				{
IWantTryAgain:
					if( !actorReachable(SpecialCost) )
					{
						Node2 = FindPathToward(SpecialCost);
						if( Node2==None )
						{
							PlayRunning();
							MoveToward(SpecialCost,GroundSpeed);
						}
						else
						{
							PlayRunning();
							MoveToward(Node2,GroundSpeed);
							if( OldMoveVect==Node2.Location )
							{
								Acceleration = vect(0,0,0);
								PlayWaiting();
								Sleep(0.5);
							}
							OldMoveVect = Node2.Location;
							GoTo 'IWantTryAgain';
						}
					}
					else
					{
						PlayRunning();
						MoveToward(SpecialCost,GroundSpeed);
						Acceleration = vect(0,0,0);
						PlayWaiting();
						Sleep(0.5);
						GoTo 'Skip';
					}
				}
			}
			GoTo 'Skip';
		}
		else
		{
			if( LiftExit(OldNode).LiftTrigger!='' )
			{
				SpecialCost = GetTrigger(LiftExit(OldNode).LiftTrigger);
				if( SpecialCost!=None )
				{
IWantTryAgain2:
					if( !actorReachable(SpecialCost) )
					{
						Node2 = FindPathToward(SpecialCost);
						if( Node2==None )
						{
							PlayRunning();
							MoveToward(SpecialCost,GroundSpeed);
						}
						else
						{
							PlayRunning();
							MoveToward(Node2,GroundSpeed);
							if( OldMoveVect==Node2.Location )
							{
								Acceleration = vect(0,0,0);
								PlayWaiting();
								Sleep(0.5);
							}
							OldMoveVect = Node2.Location;
							GoTo 'IWantTryAgain2';
						}
					}
					else
					{
						PlayRunning();
						MoveToward(SpecialCost,GroundSpeed);
						Acceleration = vect(0,0,0);
						PlayWaiting();
						Sleep(0.5);
						GoTo 'MoveAtPoint';
					}
				}
			}
			Acceleration = vect(0,0,0);
			PlayWaiting();
			TriggerMovers(LiftCenter(Node).LiftTag);
			Sleep(1);
			GoTo 'ReCheck';
		}
	}
Skip:
	if( Node.IsA('LiftExit') && !OldNode.IsA('LiftCenter') )
	{
		if( LiftExit(Node).LiftTrigger!='' )
			SpecialCost = GetTrigger(LiftExit(Node).LiftTrigger);
		else SpecialCost = None;
		if( SpecialCost!=None )
		{
DoAgain:
			if( !actorReachable(SpecialCost) )
			{
				Node2 = FindPathToward(SpecialCost);
				if( Node2==None )
				{
					PlayRunning();
					MoveToward(SpecialCost,GroundSpeed);
				}
				else
				{
					PlayRunning();
					MoveToward(Node2,GroundSpeed);
					if( OldMoveVect==Node2.Location )
					{
						Acceleration = vect(0,0,0);
						PlayWaiting();
						Sleep(0.5);
					}
					OldMoveVect = Node2.Location;
					GoTo 'DoAgain';
				}
			}
			else
			{
				PlayRunning();
				MoveToward(SpecialCost,GroundSpeed);
				Acceleration = vect(0,0,0);
				PlayWaiting();
				Sleep(0.5);
				GoTo 'MoveAtPoint';
			}
		}
	}
	MoveToward(Node,GroundSpeed);
	if( OldMoveVect==Node.Location )
	{
		Acceleration = vect(0,0,0);
		PlayWaiting();
		Sleep(0.5);
	}
	OldMoveVect = Node.Location;
	GoTo 'MoveAtPoint';

CheckLastLocation:
	CheckEnemys();
	PlayRunning();
	if( PointReachable(LastSeenPos) )
	{
		MoveTo(LastSeenPos,GroundSpeed);
		if( LineOfSightTo(Enemy) )
			GoTo 'MoveAtPoint';
		Acceleration = vect(0,0,0);
		PlayWaiting();
		Sleep(0.4);
		// I can't find the enemy :(
		Enemy = None;
		WhatToDoNext('','');
	}
	Node = FindPathTo(LastSeenPos);
	if( Node==None )
	{
		MoveTo(LastSeenPos,GroundSpeed);
		PlayWaiting();
		Sleep(1);
		Enemy = None;
		WhatToDoNext('','');
	}
	MoveToward(Node,GroundSpeed);
	if( OldMoveVect==Node.Location )
	{
		Acceleration = vect(0,0,0);
		PlayWaiting();
		Sleep(0.5);
	}
	OldMoveVect = Node.Location;
	GoTo 'CheckLastLocation';
}
event bool EncroachingOn( actor Other )
{
	if ( (Other.Brush != None) || (Brush(Other) != None) || (ZombiePawns(Other)!=None) )
		return true;

	return false;
}
State Dying
{
ignores SeePlayer, EnemyNotVisible, HearNoise, KilledBy, Trigger, Bump, Tick, HitWall, HeadZoneChange, FootZoneChange, ZoneChange, Falling, WarnTarget, Died, LongFall, PainTimer;
}
function TriggerMovers( name Check )
{
	local Mover M;
	local Trigger T;

	ForEach AllActors(class'Mover',M,Check)
	{
		if( M.Tag!='' )
			ForEach AllActors(class'Trigger',T)
				if( T.Event==M.Tag )
					T.Touch(Self);
		M.Bump(Self);
	}
}
function bool LiftMoving( name LiftT )
{
	local Mover M;

	ForEach AllActors(class'Mover',M,LiftT)
	{
		if( M.Velocity==vect(0,0,0) || M.Physics==PHYS_None )
			Return True;
		else Return false;
	}
	Return True;
}

defaultproperties
{
    bGotGreenBlood=True

    RunAnim=Run

    WalkAnim=Walk

    SwimAnim=Swimming

    IdleAnim(0)=Breath1

    IdleAnim(1)=Breath2

    DiedAnim(0)=Dieath1

    DiedAnim(1)=Dieath2

    DiedAnim(2)=Dieath3

    DiedAnim(3)=Dieath4

    GutHitAnim=GutHit

    HeadHitAnim=HeadHit

    LeftHitAnim=LeftHit

    RightHitAnim=RightHit

    FighterAnim=Fighter

    InAirAnim=InAir

    bCanStrafe=True

}